import { IFontAtlas, IFontMapping, IFontOptions, IFontService, IIconFontGlyph } from './IFontService';
export declare const DEFAULT_CHAR_SET: string[];
export declare const DEFAULT_FONT_FAMILY = "sans-serif";
export declare const DEFAULT_FONT_WEIGHT = "normal";
export declare const DEFAULT_FONT_SIZE = 24;
export declare const DEFAULT_BUFFER = 3;
export declare const DEFAULT_CUTOFF = 0.25;
export declare const DEFAULT_RADIUS = 8;
export default class FontService implements IFontService {
    fontAtlas: IFontAtlas;
    private iconFontGlyphs;
    private fontOptions;
    private key;
    private cache;
    init(): void;
    addIconGlyphs(glyphs: IIconFontGlyph[]): void;
    getGlyph(name: string): string;
    get scale(): number;
    get canvas(): HTMLCanvasElement;
    get mapping(): IFontMapping;
    setFontOptions(option: Partial<IFontOptions>): void;
    destroy(): void;
    private generateFontAtlas;
    private getKey;
    private getNewChars;
}
