import { EventEmitter } from 'eventemitter3';
import { ITexture2D } from '../renderer/ITexture2D';
import { IICONMap, IIconService, IImage } from './IIconService';
export default class IconService extends EventEmitter implements IIconService {
    canvasHeight: number;
    private texture;
    private canvas;
    private iconData;
    private iconMap;
    private ctx;
    init(): void;
    addImage(id: string, image: IImage): void;
    getTexture(): ITexture2D;
    getIconMap(): IICONMap;
    getCanvas(): HTMLCanvasElement;
    hasImage(id: string): boolean;
    removeImage(id: string): void;
    destroy(): void;
    private update;
    private updateIconAtlas;
    private updateIconMap;
    private loadImage;
}
